package com.zksy.data.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zksy.data.annotation.XhDataLogRecord;
import com.zksy.data.domain.po.XcrDishonestyPunishment19;
import com.zksy.data.domain.response.XcrDishonestyPunishment19Response;
import com.zksy.data.mapper.XcrDishonestyPunishment19Mapper;
import com.zksy.data.service.XcrDishonestyPunishment19Service;
import com.zksy.data.utils.RedisService;
import com.zksy.data.utils.XhRequestUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.HashMap;
import java.util.List;
import java.util.Vector;

/**
* @author Administrator
* @description 针对表【xcr_dishonesty_punishment_19(严重失信主体名单表)】的数据库操作Service实现
* @createDate 2024-10-15 12:03:18
*/
@Service
@Slf4j
public class XcrDishonestyPunishment19ServiceImpl extends ServiceImpl<XcrDishonestyPunishment19Mapper, XcrDishonestyPunishment19>
    implements XcrDishonestyPunishment19Service{
    @Autowired
    private XhRequestUtil xhRequestUtil;
    @Autowired
    private RedisService redisService;
    @Override
    @Transactional(rollbackFor = Exception.class)
    @XhDataLogRecord("同步严重失信主体名单表")
    public void saveDataByUniCode(String address) {
        //模拟从数据库中取数据大约为3000-4000条
        List<String> creditCodes = (List<String>) redisService.getList("creditCodes").get(0);
        Vector<XcrDishonestyPunishment19> toDatabaseList = new Vector<>();
        List<String> inventoryList = List.of("19");
        inventoryList.parallelStream().forEach(inventory -> {
            creditCodes.parallelStream().forEach(creditCode -> {
                HashMap<String, String> requestbodyMap = new HashMap<>();
                requestbodyMap.put("entityCode", creditCode);
                requestbodyMap.put("size", String.valueOf(10));
                requestbodyMap.put("page", String.valueOf(1));
                requestbodyMap.put("inventoryId", inventory);
                try {
                    List<XcrDishonestyPunishment19> list = xhRequestUtil.requestXinyonghuanhuai2(requestbodyMap,address,
                            XcrDishonestyPunishment19Response.class,
                            XcrDishonestyPunishment19.class);
                    if(list != null){
                        toDatabaseList.addAll(list);
                    }
                } catch (Exception e) {
                    List<XcrDishonestyPunishment19> list = xhRequestUtil.requestXinyonghuanhuai2(requestbodyMap,address,
                            XcrDishonestyPunishment19Response.class,
                            XcrDishonestyPunishment19.class);
                    if(list != null){
                        toDatabaseList.addAll(list);
                    }
                }
            });
            log.info("inventorywe为:{}完成",inventory);
        });
        this.remove(null);
        this.saveBatch(toDatabaseList);
        log.info("严重失信主体名单表同步完成");
    }
}




